/*!
 * api-render-vue v0.0.1-alpha.16
 * An API data parsing tool.
 * © 2024-2024 @jl15988(https://github.com/jl15988)
 * MIT License.
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("vue")):"function"==typeof define&&define.amd?define(["exports","vue"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).apiRenderVue={},e.Vue)}(this,(function(e,t){"use strict";var r=Object.freeze({__proto__:null,get ApiRenderTool(){return m},get ApiRenderUtils(){return B},get default(){return P},get defineApiRenderOptions(){return w},get getApiRenderCache(){return c},get getApiRenderConfig(){return i},get reloadApiRenderCache(){return h},get setApiRenderCache(){return p},get setApiRenderConfig(){return a}});const n={openCache:!0,cacheTimeout:3e5,openClearCache:!0,clearCacheSpace:6e4,defaultLabelKey:"label",defaultValueKey:"value",defaultTreeLabelKey:"label",defaultTreeValueKey:"value",defaultTreeIdKey:"id",defaultTreeChildrenKey:"children",defaultTreeParentIdKey:"parentId",defaultOptionsValueKey:"value",defaultOptionsLabelKey:"label"};function a(e){Object.assign(e,n)}function i(){return Object.assign({},n)}const u=new Map,o=new Map;let l=0;function s(){return n.openClearCache?l+n.clearCacheSpace>Date.now()?Promise.resolve(!0):(l=Date.now(),new Promise((e=>{for(const[e,t]of u.entries())t.timeout>Date.now()||u.delete(e);e(!0)}))):Promise.resolve(!0)}async function f(e,t){const r=y(e,t);let n=o.get(r);n||(o.set(r,e()),n=o.get(r));const a=await n;return o.delete(r),a}function y(e,t){if(t)return t;if(!e)throw Error("api and key must have one of them.");return e.name?e:""+e}function p(e,t,r){if(!t&&!r)throw Error("api and key must have one of them.");const a={value:e,api:t||(()=>Promise.resolve(void 0)),timestamp:Date.now(),timeout:Date.now()+n.cacheTimeout};u.set(y(t,r),a)}async function c(e,t){if(!e)return Promise.resolve(void 0);const r=u.get(y(e,t));if(!n.openCache||!n.cacheTimeout||0>=n.cacheTimeout)return await f(e,t);if(!r||r&&n.openClearCache&&r.timeout&&r.timeout<=Date.now()){const r=await f(e,t);return p(r,e,t),s(),r}return s(),Promise.resolve(r.value)}async function d(e,t){const r=function(e){if("string"==typeof e||"number"==typeof e)return e}(e);p(await f(t.api,r),t.api,r)}async function h(...e){if(!e){for(const[e,t]of u.entries())t&&t.api?await d(e,t):u.delete(e);return Promise.resolve()}for(let t of e){const e=u.get(t);if(!e||!e.api)return Promise.resolve();await d(t,e)}s()}var A=new class{repeat(e,t){return e.join("").repeat(t)}finalItem(e,t){return K.isEmpty(e)?t:e[e.length-1]||t}push(e,t){return Array.isArray(e)&&e.length>=0?(e.push(t),e):[t]}isEmpty(e){return!e||0===e.length}isNotEmpty(e){return!this.isEmpty(e)}defaultIfEmpty(e,t){return this.isEmpty(e)?t:e}fixedUnshift(e,t,...r){e.unshift(...r.reverse());let n=[];return e.length>t&&(n=e.splice(t,e.length-t)),n}fixedPush(e,t,...r){e.push(...r);let n=[];return e.length>t&&(n=e.splice(0,e.length-t)),n}deepCopy(e){return Array.isArray(e)?e.map((e=>Array.isArray(e)?this.deepCopy(e):"object"==typeof e&&null!==e?K.deepCopy(e):e)):[]}deepAssign(e,t){return t&&Array.isArray(t)?t.map(((t,r)=>null==t?e[r]:Array.isArray(t)?this.deepAssign(e[r]&&!Array.isArray(e[r])?[]:e[r]||[],t):"object"==typeof t?K.deepAssign(e[r]&&Array.isArray(e[r])?{}:e[r]||{},t):t)):e}unique(e,t){const r=[];return e.reduce(((e,n)=>{const a=t?t(n):n;return r.includes(a)||(e.push(n),r.push(a)),e}),[])}intersection(...e){const[t,...r]=e;return this.unique(t.filter((e=>r.every((t=>t.includes(e))))))}union(...e){return this.unique([].concat(...e))}difference(...e){const t=this.intersection(...e);return[].concat(...e).reduce(((e,r)=>(e.includes(r)||t.includes(r)||e.push(r),e)),[])}groupBy(e,t){return e.reduce(((e,r)=>{const n=""+t(r);return e[n]||(e[n]=[]),e[n].push(r),e}),{})}};var K=new class{isEmpty(e){return null==e||("string"==typeof e&&""===e.trim()||(!(!Array.isArray(e)||0!==e.length)||"object"==typeof e&&0===Object.keys(e).length))}deepCopy(e){if("object"!=typeof e||null===e)return e;const t=Array.isArray(e)?[]:{};for(const r in e)if(e.hasOwnProperty(r)){const n=e[r];t[r]=Array.isArray(n)?A.deepCopy(e[r]):this.deepCopy(n)}return t}deepAssign(e,...t){if(!t)return e;for(let r of t)if("object"==typeof r)for(const t in r)if(r.hasOwnProperty(t)){const n=r[t];if(null==n)continue;e[t]=Array.isArray(n)?A.deepAssign(n&&!Array.isArray(n)?[]:e[t]||[],r[t]):"object"!=typeof n?n:this.deepAssign(e[t]&&Array.isArray(e[t])?{}:e[t]||{},n)}return e}deepAssignByKey(e,t,...r){return r?(e[t]||(e[t]={}),this.deepAssign(e[t],...r)):e}appendIfNotEmpty(e,t){return this.isEmpty(e)?"":(""+e).concat(t)}defaultIfNotBoolean(e,t=""){return"boolean"==typeof e?e:this.isEmpty(e)?t:e}};var m=new class{getItemByValue(e,t,r){return r=r||n.defaultValueKey,Array.isArray(e)?e.find((e=>e&&e[r]===t)):e[r]}async getApiItem(e,t,r,n){const a=await c(e,n);if(a)return this.getItemByValue(a,r,t)}renderValueByItem(e,t){if(K.isEmpty(e))return"";if("object"==typeof e){return K.defaultIfNotBoolean(e[t||n.defaultLabelKey])}return K.defaultIfNotBoolean(e)}async renderValue(e,t,r,n,a){const i=await this.getApiItem(e,t,r,a);this.renderValueByItem(i,n)}async renderOptions(e,t,r,a){const i=await c(e,a);return i?i.map((e=>({label:e[r||n.defaultLabelKey],value:e[t||n.defaultValueKey],key:e[t||n.defaultValueKey]}))):[]}};async function b(e,t,r,n,a){await _(e,t);const i=L.value[t];if(!i)return"";a=R(t,a),n=j(t,n);const u=m.getItemByValue(i,r,n);return m.renderValueByItem(u,a)}var g=new class{LEVEL_NAME="__tree_level";LEVEL_BEGIN=1;BUILT_TAG="__built_tag";buildTree(e,t,r,n,a,i,u){if(!e)return[];let o=A.deepCopy(e);return a=a||this.LEVEL_NAME,this.buildTreeMapper(o,t,r,((e,t,r,u)=>(u!==this.LEVEL_BEGIN&&(t[n]=r),e[a]=u,i&&i(e,t,r,u),e)),u),o}buildCommonTree(e,t,r,n,a,i,u){return this.filterRoot(this.buildTree(e,t,r,n,a,i,u))}filterRoot(e,t){return t=t||this.LEVEL_NAME,e.filter((e=>e[t]===this.LEVEL_BEGIN))}buildTreeMapper(e,t,r,n,a){if(!A.isEmpty(e))for(let i of e){const u=this.LEVEL_BEGIN;if(i[this.BUILT_TAG])return;n&&n(i,null,[],u),this.toTreeMapper(e,i,t,r,n,a,u)}}toTreeMapper(e,t,r,n,a,i,u){const o=[];for(let a of e)a[n]===t[r]&&(a[this.BUILT_TAG]=!0,o.push(a));if(o.length>0)for(let l of o){const s=(u||this.LEVEL_BEGIN-1)+1,f=a?a(l,t,o,s):l;this.toTreeMapper(e,f,r,n,a,i,s)}else i&&i(t)}};function v(e,t,r){_(e,t);const a=V(t);if(!a||!Array.isArray(a))return[];let{labelKey:i,valueKey:u,treeLabelKey:o,treeValueKey:l,treeChildrenKey:s,parentKey:f,idKey:y}=r;i=R(t,i),u=j(t,u),o=function(e,t){return t||(C[e]&&C[e].treeLabelKey||n.defaultTreeLabelKey)}(t,o),l=j(t,l),s=function(e,t){return t||(C[e]&&C[e].treeChildrenKey||n.defaultTreeChildrenKey)}(t,s),f=function(e,t){return t||(C[e]&&C[e].treeParentIdKey||n.defaultTreeParentIdKey)}(t,f),y=function(e,t){return t||(C[e]&&C[e].treeIdKey||n.defaultTreeIdKey)}(t,y);const p=a.map((e=>({[o]:e[i],[l]:e[u]})));return g.buildCommonTree(p,y,f,s)}function T(e,t,r){_(e,t);const a=V(t);if(!a||!Array.isArray(a))return[];let{valueKey:i,labelKey:u,dataValueKey:o,dataLabelKey:l}=r;return u=R(t,u),i=j(t,i),o=function(e,t){return t||(C[e]&&C[e].optionsValueKey||n.defaultOptionsValueKey)}(t,o),l=function(e,t){return t||(C[e]&&C[e].optionsLabelKey||n.defaultOptionsLabelKey)}(t,l),a.map((e=>({[l]:e[u],[o]:e[i],key:e[i]})))}const E={},L=t.ref({}),C={};function V(e){return L.value[e]}function I(){return{labelKey:n.defaultLabelKey,valueKey:n.defaultValueKey,treeValueKey:n.defaultTreeValueKey,treeLabelKey:n.defaultTreeLabelKey,treeIdKey:n.defaultTreeIdKey,treeChildrenKey:n.defaultTreeChildrenKey,treeParentIdKey:n.defaultTreeParentIdKey,optionsValueKey:n.defaultOptionsValueKey,optionsLabelKey:n.defaultOptionsLabelKey}}function w(e){const r={},n=I();for(let t in e)e[t]=Object.assign({},n,e[t]),r[t]=t;Object.assign(E,e);return{keysMap:r,ApiRender:t.defineComponent({name:"ApiRender",props:{apiKey:{type:[String],required:!0},value:{type:[String,Number,Boolean,Object]}},setup(r){const n=t.ref(""),{apiKey:a,value:i}=r;return b(e,a,i).then((e=>{n.value=e})),()=>n.value}}),renderApiValue:function(t,r,n,a){return b(e,t,r,n,a)},renderApiOptions:function(t,r){return T(e,t,r)},renderApiTree:function(t,r){return v(e,t,r)},reloadApiRenderOptionsData:function(...t){const r=t?t.map((e=>""+e)):Object.keys(L.value);h(...r).then((()=>{for(let t of r)O(e,t)}))}}}async function O(e,t){const r=e[t];r&&(C[t]=I(),r instanceof Function?L.value[t]=await c(r,""+t):(L.value[t]=await c(r.api,""+t),C[t]=Object.assign({},C[t],{labelKey:r.labelKey||n.defaultLabelKey,valueKey:r.valueKey||n.defaultValueKey})))}async function _(e,t){L.value[t]||await O(e,t)}function R(e,t){return t||(C[e]&&C[e].labelKey||n.defaultLabelKey)}function j(e,t){return t||(C[e]&&C[e].valueKey||n.defaultValueKey)}const B={ArrayUtil:A,ObjectUtil:K,TreeUtil:g},P=r;e.ApiRenderTool=m,e.ApiRenderUtils=B,e.default=P,e.defineApiRenderOptions=w,e.getApiRenderCache=c,e.getApiRenderConfig=i,e.reloadApiRenderCache=h,e.setApiRenderCache=p,e.setApiRenderConfig=a,Object.defineProperty(e,"__esModule",{value:!0})}));
